#include <memory>
#include <list>
#include <string>
#include <iostream>

typedef std::shared_ptr<std::list<std::string>> PointerToStringList1;

using PointerToStringList2 = std::shared_ptr<std::list<std::string>>;

/*********************************************************************************************************/

template<class T>
struct MyAlloc: std::allocator<T> // change to class. Any changes?
{

};

namespace CPP98
{
    template<typename T>
    struct MyAllocList
    {
        typedef std::list<T, MyAlloc<T>> type;
    };

    MyAllocList<int>::type myList;

    template<typename T>
    struct XXX
    {
        typename MyAllocList<T>::type m_list;
    };
}

/*********************************************************************************************************/

namespace CPP11
{

    template<typename T>
    using MyAllocList = std::list<T, MyAlloc<T>>;

    MyAllocList<int> myList;

    template<typename T>
    struct XXX
    {
       MyAllocList<T> m_list;
    };
}

int main(int, char **)
{
    PointerToStringList1 p1;
    std::cout << p1.use_count() << std::endl;

    PointerToStringList2 p2;
    std::cout << p2.use_count() << std::endl;

    std::cout << "******************************************" << std::endl;

    {
        CPP98::myList.push_back(10);
        CPP98::XXX<double> xxx;
        xxx.m_list.push_back(20.0);
    }

    {
        CPP11::myList.push_back(10);
        CPP11::XXX<double> xxx;
        xxx.m_list.push_back(20.0);
    }

    return 0;
}
