#include <iostream>

template<typename T>
int sum(const T& arg)
{
    std::cout << __PRETTY_FUNCTION__ << std::endl;
    return arg;
}

//int sum()
//{
//    std::cout << __PRETTY_FUNCTION__ << std::endl;
//    return 0;
//}

template<typename Arg1Type, typename... ArgsTypes>
int sum(const Arg1Type& arg1, const ArgsTypes&... args)
{
    std::cout << __PRETTY_FUNCTION__ << std::endl;
    return arg1 + sum(args...);
}

class Foo
{
public:
   explicit Foo(int value):m_value(value)
   {
   }

   operator int() const
   {
       return m_value;
   }

private:
   int m_value;
};

int main(int, char**)
{
    std::cout << sum(10) << std::endl;
    std::cout << "********************************************************" << std::endl;

    std::cout << sum(Foo(200)) << std::endl;
    std::cout << "********************************************************" << std::endl;

    std::cout << sum(10, 20) << std::endl;
    std::cout << "********************************************************" << std::endl;

    std::cout << sum(10, Foo(20)) << std::endl;
    std::cout << "********************************************************" << std::endl;

    std::cout << sum(Foo(20), 10) << std::endl;
    std::cout << "********************************************************" << std::endl;

    std::cout << sum(Foo(10), Foo(20)) << std::endl;
    std::cout << "********************************************************" << std::endl;

    std::cout << sum(Foo(100), 1, Foo(500), 2, Foo(200)) << std::endl;
    std::cout << "********************************************************" << std::endl;
    //std::cout << sum() << std::endl;
    return 0;
}
